#!/usr/bin/python

import sys, os
from PyQt5.QtWidgets import (QApplication, QMainWindow, QDesktopWidget, 
							QMessageBox, QPlainTextEdit, QAction, 
							QFileDialog, QFontDialog)
from PyQt5.QtGui import QIcon
from PyQt5.Qt import QLocale

class Okno(QMainWindow):
	def __init__(self):
		super().__init__()
		self.zapusk()

	def centrirovat(self):
		geometriya = self.frameGeometry()
		centr = QDesktopWidget().availableGeometry().center()
		geometriya.moveCenter(centr)
		self.move(geometriya.topLeft())
	
	def vstavitSimvol(self):
		otpravitel = self.sender()
		self.redaktirovaniye.insertPlainText(otpravitel.text())


	def zamenitNaPsevdokod(self):
		tekst = self.redaktirovaniye.toPlainText()
		tekst = tekst.replace('Ĉ', 'Cx');
		tekst = tekst.replace('ĉ', 'cx');
		tekst = tekst.replace('Ĝ', 'Gx');
		tekst = tekst.replace('ĝ', 'gx');
		tekst = tekst.replace('Ĥ', 'Hx');
		tekst = tekst.replace('ĥ', 'hx');
		tekst = tekst.replace('Ĵ', 'Jx');
		tekst = tekst.replace('ĵ', 'jx');
		tekst = tekst.replace('Ŝ', 'Sx');
		tekst = tekst.replace('ŝ', 'sx');
		tekst = tekst.replace('Ŭ', 'Ux');
		tekst = tekst.replace('ŭ', 'ux');
		self.redaktirovaniye.setPlainText(tekst)
	
	def zamenitIzPsevdokoda(self):
		tekst = self.redaktirovaniye.toPlainText()
		tekst = tekst.replace('Cx', 'Ĉ');
		tekst = tekst.replace('CX', 'Ĉ');
		tekst = tekst.replace('cx', 'ĉ');
		tekst = tekst.replace('Gx', 'Ĝ');
		tekst = tekst.replace('GX', 'Ĝ');
		tekst = tekst.replace('gx', 'ĝ');
		tekst = tekst.replace('Hx', 'Ĥ');
		tekst = tekst.replace('HX', 'Ĥ');	
		tekst = tekst.replace('hx', 'ĥ');
		tekst = tekst.replace('Jx', 'Ĵ');
		tekst = tekst.replace('JX', 'Ĵ');
		tekst = tekst.replace('jx', 'ĵ');
		tekst = tekst.replace('Sx', 'Ŝ');
		tekst = tekst.replace('SX', 'Ŝ');
		tekst = tekst.replace('sx', 'ŝ');
		tekst = tekst.replace('Ux', 'Ŭ');
		tekst = tekst.replace('UX', 'Ŭ');
		tekst = tekst.replace('ux', 'ŭ');
		self.redaktirovaniye.setPlainText(tekst)
		
	def perekluchitRezhimPerenosaSlov(self):
		self.perenosSlov = not self.perenosSlov
		self.redaktirovaniye.setWordWrapMode(self.perenosSlov)
		self.nastroykaPerenosSlov.setChecked(self.perenosSlov)
			
	def otkrit(self):
		esperanto = False
		if QLocale.system().nativeLanguageName() == "esperanto":
			esperanto = True
		vybranniyeFayly = QFileDialog.getOpenFileName(self, 'Выберите файл для чтения' if not esperanto else "Selekti dosiero por legado", '/', 'Текстовые файлы (*)' if not esperanto else "Tekstaj dosieroj (*)")		
		file = str(vybranniyeFayly[0])
		if (file != ''):
			try:
				with open(file) as f:
					self.redaktirovaniye.setPlainText(f.read())
			except Exception:
				oknoSoobscheniya = QMessageBox(self)
				oknoSoobscheniya.setText('Ошибка чтения выбранного файла.')
				oknoSoobscheniya.setIcon(QMessageBox.Critical)
				oknoSoobscheniya.setWindowTitle('Ошибка')
				oknoSoobscheniya.addButton('Закрыть', QMessageBox.YesRole)
				oknoSoobscheniya.exec_()
	
	def sohranitKak(self):
		esperanto = False
		if QLocale.system().nativeLanguageName() == "esperanto":
			esperanto = True
		vybranniyeFayly = QFileDialog.getSaveFileName(self, 'Выберите файл для записи' if not esperanto else "Selekti dosiero por konservado", '/', 'Текстовые файлы  (*)'  if not esperanto else "Tekstaj dosieroj (*)")		
		file = str(vybranniyeFayly[0])
		if (file != ''):
			try:
				with open(file, 'w') as f:
					f.write(self.redaktirovaniye.toPlainText())
			except Exception:
				oknoSoobscheniya = QMessageBox(self)
				oknoSoobscheniya.setText('Ошибка записи данных в файл.')
				oknoSoobscheniya.setIcon(QMessageBox.Critical)
				oknoSoobscheniya.setWindowTitle('Ошибка')
				oknoSoobscheniya.addButton('Закрыть', QMessageBox.YesRole)
				oknoSoobscheniya.exec_()

	def perekluchitRezhimPerenosaSlov(self):
		self.perenosSlov = not self.perenosSlov
		self.redaktirovaniye.setWordWrapMode(self.perenosSlov)
		self.nastroykaPerenosSlov.setChecked(self.perenosSlov)
			
	def vybratShrift(self):
		esperanto = False
		if QLocale.system().nativeLanguageName() == "esperanto":
			esperanto = True
		shrift, rezultat = QFontDialog.getFont(self.redaktirovaniye.font(), None, 'Выберите шрифт для отображения' if not esperanto else 'Selekti tiparon')
		if rezultat:
			self.redaktirovaniye.setFont(shrift)
	
	def oProgramme(self):
		esperanto = False
		if QLocale.system().nativeLanguageName() == "esperanto":
			esperanto = True
		versiya = "2024.04.22"
		oknoSoobscheniya = QMessageBox(self)
		oknoSoobscheniya.setText('Ввод символов с надстрочными знаками (диакритикой).\nСборка ' + versiya + '.\nСтраница проекта: языкэсперанто.рф')
		oknoSoobscheniya.setIcon(QMessageBox.Information)
		oknoSoobscheniya.setWindowTitle('О программе')
		oknoSoobscheniya.addButton('Закрыть' if not esperanto else "Fermi", QMessageBox.YesRole)
		if esperanto:
			oknoSoobscheniya.setWindowTitle('Pri la aplikaĵo')
			oknoSoobscheniya.setText('Krajono: la tekstredaktilo por enigi leterojn kun superskribaj signoj.\nRedakcio ' + versiya + '.\nProektpaĝo: языкэсперанто.рф')
		oknoSoobscheniya.exec_()								
			
	def zapusk(self):
		self.redaktirovaniye = QPlainTextEdit()
		self.perenosSlov = True		
		self.redaktirovaniye.setWordWrapMode(self.perenosSlov)
		self.setCentralWidget(self.redaktirovaniye)
		
		katalogResursov = str(os.path.dirname(os.path.abspath(__file__))) + str(os.sep) + "rimedoj" + str(os.sep)
		
		esperanto = False
		if QLocale.system().nativeLanguageName() == "esperanto":
			esperanto = True
		
		#Добавление строки меню
		menu = self.menuBar()
		
		#Команды меню Файл
		otkrit = QAction('Открыть...', self)		
		otkrit.setShortcut('Ctrl+O')
		otkrit.setStatusTip('Открыть текст из файла')
		otkrit.setIcon(QIcon(katalogResursov + 'malfermi.png'))
		if esperanto:
			otkrit.setText("Malfermi...")
			otkrit.setStatusTip("Legi tekston el dosiero")
		otkrit.triggered.connect(self.otkrit)
		
		sohranitKak = QAction('Сохранить как...', self)
		sohranitKak.setShortcut('Ctrl+S')
		sohranitKak.setStatusTip('Сохранить текст в файл')
		sohranitKak.setIcon(QIcon(katalogResursov + 'konservi.png'))
		if esperanto:
			sohranitKak.setText("Konservi kiel...")
			sohranitKak.setStatusTip("Scribi la tekston en dosiero")
		sohranitKak.triggered.connect(self.sohranitKak)
		
		vyhod = QAction('Выход', self)
		vyhod.setShortcut('Ctrl+Q')
		vyhod.setStatusTip('Выход из приложения')
		vyhod.setIcon(QIcon(katalogResursov + 'eliri.png'))
		if esperanto:
			vyhod.setText("Eliri")
			vyhod.setStatusTip("Eliri el la redaktilo")
		vyhod.triggered.connect(self.close)
		
		fileMenu = menu.addMenu('Файл')
		if esperanto:
			fileMenu.setTitle("Dosiero")	
		fileMenu.addAction(otkrit)
		fileMenu.addAction(sohranitKak)
		fileMenu.addSeparator()
		fileMenu.addAction(vyhod)
		
		#Команды меню Правка
		pravkaVyrezat = QAction('Вырезать', self)
		if esperanto:
			pravkaVyrezat.setText("Eltondi")
		pravkaVyrezat.setShortcut('Ctrl+X')
		pravkaVyrezat.setStatusTip(pravkaVyrezat.text())
		pravkaVyrezat.setIcon(QIcon(katalogResursov + 'eltondi.png'))
		pravkaVyrezat.triggered.connect(self.redaktirovaniye.cut)

		pravkaKopirovat = QAction('Копировать', self)
		if esperanto:
			pravkaKopirovat.setText("Kopii")
		pravkaKopirovat.setShortcut('Ctrl+C')
		pravkaKopirovat.setStatusTip(pravkaKopirovat.text())
		pravkaKopirovat.setIcon(QIcon(katalogResursov + 'kopii.png'))
		pravkaKopirovat.triggered.connect(self.redaktirovaniye.copy)
		
		pravkaVstavit = QAction('Вставить', self)
		if esperanto:
			pravkaVstavit.setText("Alglui")
		pravkaVstavit.setShortcut('Ctrl+V')
		pravkaVstavit.setStatusTip(pravkaVstavit.text())
		pravkaVstavit.setIcon(QIcon(katalogResursov + 'alglui.png'))
		pravkaVstavit.triggered.connect(self.redaktirovaniye.paste)

		pravkaNaPsevdokod = QAction('Заменить буквы на псевдокод', self)
		pravkaNaPsevdokod.setStatusTip("Замена букв с надстрочными знаками на псевдокод")
		pravkaNaPsevdokod.setIcon(QIcon(katalogResursov + 'leterojenpseuxdokodoj.png'))
		if esperanto:
			pravkaNaPsevdokod.setText("Anstatauiĝi literojn per pseŭdokodojn")
			pravkaNaPsevdokod.setStatusTip("Anstatauiĝi literojn per pseŭdokodojn")
		pravkaNaPsevdokod.triggered.connect(self.zamenitNaPsevdokod)

		pravkaIzPsevdokoda = QAction('Заменить псевдокод на буквы', self)
		pravkaIzPsevdokoda.setStatusTip("Замена псевдокода на буквы с надстрочными знаками")
		pravkaIzPsevdokoda.setIcon(QIcon(katalogResursov + 'pseuxdokodojenleteroj.png'))
		if esperanto:
			pravkaIzPsevdokoda.setText("Anstatauiĝi pseŭdokodojn per literojn")
			pravkaIzPsevdokoda.setStatusTip("Anstatauiĝi pseŭdokodojn per literojn")
		pravkaIzPsevdokoda.triggered.connect(self.zamenitIzPsevdokoda)
		
		pravkaMenu = menu.addMenu('Правка')
		if esperanto:
			pravkaMenu.setTitle("Redakti")
		pravkaMenu.addAction(pravkaVyrezat)
		pravkaMenu.addAction(pravkaKopirovat)
		pravkaMenu.addAction(pravkaVstavit)
		pravkaMenu.addSeparator()
		pravkaMenu.addAction(pravkaNaPsevdokod)
		pravkaMenu.addAction(pravkaIzPsevdokoda)
				
		#Команды меню Вставка
		vvstavitSimvol = 'Вставить символ '
		if esperanto:
			vvstavitSimvol = 'Enmeti signon '
			
		vstavkaCx = QAction('Ĉ', self)
		vstavkaCx.setShortcut('Alt+Shift+C')
		vstavkaCx.setStatusTip(vvstavitSimvol + vstavkaCx.text())
		vstavkaCx.setIcon(QIcon(katalogResursov + 'cxg.png'))
		vstavkaCx.triggered.connect(self.vstavitSimvol)

		vstavkacx = QAction('ĉ', self)
		vstavkacx.setShortcut('Alt+C')
		vstavkacx.setStatusTip(vvstavitSimvol + vstavkacx.text())
		vstavkacx.setIcon(QIcon(katalogResursov + 'cxmg.png'))
		vstavkacx.triggered.connect(self.vstavitSimvol)

		vstavkaGx = QAction('Ĝ', self)
		vstavkaGx.setShortcut('Alt+Shift+G')
		vstavkaGx.setStatusTip(vvstavitSimvol + vstavkaGx.text())
		vstavkaGx.setIcon(QIcon(katalogResursov + 'gxg.png'))
		vstavkaGx.triggered.connect(self.vstavitSimvol)

		vstavkagx = QAction('ĝ', self)
		vstavkagx.setShortcut('Alt+g')
		vstavkagx.setStatusTip(vvstavitSimvol + vstavkagx.text())
		vstavkagx.setIcon(QIcon(katalogResursov + 'gxmg.png'))
		vstavkagx.triggered.connect(self.vstavitSimvol)

		vstavkaHx = QAction('Ĥ', self)
		vstavkaHx.setShortcut('Alt+Shift+H')
		vstavkaHx.setStatusTip(vvstavitSimvol + vstavkaHx.text())
		vstavkaHx.setIcon(QIcon(katalogResursov + 'hxg.png'))
		vstavkaHx.triggered.connect(self.vstavitSimvol)

		vstavkahx = QAction('ĥ', self)
		vstavkahx.setShortcut('Alt+H')
		vstavkahx.setStatusTip(vvstavitSimvol + vstavkahx.text())
		vstavkahx.setIcon(QIcon(katalogResursov + 'hxmg.png'))
		vstavkahx.triggered.connect(self.vstavitSimvol)

		vstavkaJx = QAction('Ĵ', self)
		vstavkaJx.setShortcut('Alt+Shift+J')
		vstavkaJx.setStatusTip(vvstavitSimvol + vstavkaJx.text())
		vstavkaJx.setIcon(QIcon(katalogResursov + 'jxg.png'))
		vstavkaJx.triggered.connect(self.vstavitSimvol)

		vstavkajx = QAction('ĵ', self)
		vstavkajx.setShortcut('Alt+J')
		vstavkajx.setStatusTip(vvstavitSimvol + vstavkajx.text())
		vstavkajx.setIcon(QIcon(katalogResursov + 'jxmg.png'))
		vstavkajx.triggered.connect(self.vstavitSimvol)

		vstavkaSx = QAction('Ŝ', self)
		vstavkaSx.setShortcut('Alt+Shift+S')
		vstavkaSx.setStatusTip(vvstavitSimvol + vstavkaSx.text())
		vstavkaSx.setIcon(QIcon(katalogResursov + 'sxg.png'))
		vstavkaSx.triggered.connect(self.vstavitSimvol)

		vstavkasx = QAction('ŝ', self)
		vstavkasx.setShortcut('Alt+S')
		vstavkasx.setStatusTip(vvstavitSimvol + vstavkasx.text())
		vstavkasx.setIcon(QIcon(katalogResursov + 'sxmg.png'))
		vstavkasx.triggered.connect(self.vstavitSimvol)

		vstavkaUx = QAction('Ŭ', self)
		vstavkaUx.setShortcut('Alt+Shift+U')
		vstavkaUx.setStatusTip(vvstavitSimvol + vstavkaUx.text())
		vstavkaUx.setIcon(QIcon(katalogResursov + 'uxg.png'))
		vstavkaUx.triggered.connect(self.vstavitSimvol)

		vstavkaux = QAction('ŭ', self)
		vstavkaux.setShortcut('Alt+U')
		vstavkaux.setStatusTip(vvstavitSimvol + vstavkaux.text())
		vstavkaux.setIcon(QIcon(katalogResursov + 'uxmg.png'))
		vstavkaux.triggered.connect(self.vstavitSimvol)

		vstavkaMnogotochiye = QAction('…', self)
		vstavkaMnogotochiye.setShortcut('Alt+.')
		vstavkaMnogotochiye.setStatusTip(vvstavitSimvol + vstavkaMnogotochiye.text())
		vstavkaMnogotochiye.setIcon(QIcon(katalogResursov + 'tripunkto.png'))
		vstavkaMnogotochiye.triggered.connect(self.vstavitSimvol)
						
		vstavkaMenu = menu.addMenu('Вставка')
		if esperanto:
			vstavkaMenu.setTitle("Enmeti")
		vstavkaMenu.addAction(vstavkaCx)
		vstavkaMenu.addAction(vstavkacx)
		vstavkaMenu.addAction(vstavkaGx)
		vstavkaMenu.addAction(vstavkagx)
		vstavkaMenu.addAction(vstavkaHx)
		vstavkaMenu.addAction(vstavkahx)
		vstavkaMenu.addAction(vstavkaJx)
		vstavkaMenu.addAction(vstavkajx)
		vstavkaMenu.addAction(vstavkaSx)
		vstavkaMenu.addAction(vstavkasx)
		vstavkaMenu.addAction(vstavkaUx)
		vstavkaMenu.addAction(vstavkaux)
		vstavkaMenu.addSeparator()
		vstavkaMenu.addAction(vstavkaMnogotochiye)

		#Команды меню Настройка		
		self.nastroykaPerenosSlov = QAction('Перенос по словам', self)
		self.nastroykaPerenosSlov.setStatusTip('Переключить режим переноса по словам')
		self.nastroykaPerenosSlov.setCheckable(True)
		self.nastroykaPerenosSlov.setChecked(True)
		if esperanto:
			self.nastroykaPerenosSlov.setText("Vortotransporto")
			self.nastroykaPerenosSlov.setStatusTip("Ŝalti vortotransporto")
		self.nastroykaPerenosSlov.triggered.connect(self.perekluchitRezhimPerenosaSlov)
		
		nastroykaVybratShrift = QAction('Выбрать шрифт...', self)
		nastroykaVybratShrift.setStatusTip('Выбрать шрифт')
		nastroykaVybratShrift.setIcon(QIcon(katalogResursov + 'tiparo.png'))
		if esperanto:
			nastroykaVybratShrift.setText("Selekti tiparon...")
			nastroykaVybratShrift.setStatusTip("Selekti tiparon por uzado")
		nastroykaVybratShrift.triggered.connect(self.vybratShrift)
		
		nastroykaMenu = menu.addMenu('Настройка')
		if esperanto:
			nastroykaMenu.setTitle("Agordaĵoj")
		nastroykaMenu.addAction(self.nastroykaPerenosSlov)
		nastroykaMenu.addAction(nastroykaVybratShrift)	
		
		#Команды меню Справка
		oProgramme = QAction('О программе...', self)
		oProgramme.setStatusTip('Информация о программе')
		oProgramme.setIcon(QIcon(katalogResursov + 'informo.png'))
		if esperanto:
			oProgramme.setText("Pri la aplikaĵo...")
			oProgramme.setStatusTip('Informo pri la aplikaĵo')
		oProgramme.triggered.connect(self.oProgramme)
	
		spravkaMenu = menu.addMenu('Справка')
		if esperanto:
			spravkaMenu.setTitle("Helpo")	
		spravkaMenu.addAction(oProgramme)
							
		#Заполнение панели инструментов		
		self.toolbar = self.addToolBar('Панель инструментов')
		self.toolbar.addAction(otkrit)
		self.toolbar.addAction(sohranitKak)
		self.toolbar.addSeparator()
		self.toolbar.addAction(pravkaVyrezat)
		self.toolbar.addAction(pravkaKopirovat)
		self.toolbar.addAction(pravkaVstavit)
		self.toolbar.addSeparator()
		self.toolbar.addAction(vstavkaCx)
		self.toolbar.addAction(vstavkacx)
		self.toolbar.addAction(vstavkaGx)
		self.toolbar.addAction(vstavkagx)
		self.toolbar.addAction(vstavkaHx)
		self.toolbar.addAction(vstavkahx)
		self.toolbar.addAction(vstavkaJx)
		self.toolbar.addAction(vstavkajx)
		self.toolbar.addAction(vstavkaSx)
		self.toolbar.addAction(vstavkasx)
		self.toolbar.addAction(vstavkaUx)
		self.toolbar.addAction(vstavkaux)
		self.toolbar.addSeparator()
		self.toolbar.addAction(vstavkaMnogotochiye)
			
		self.resize(800, 600)
		self.centrirovat()
		self.setWindowTitle('Ввод символов с надстрочными знаками (диакритикой)')
		self.setWindowIcon(QIcon(katalogResursov + 'piktogramo.png'))
		self.statusBar().showMessage('')
		if esperanto:
			self.setWindowTitle('Krajono')
		self.show()
		
	def closeEvent(self, event):
		esperanto = False
		if QLocale.system().nativeLanguageName() == "esperanto":
			esperanto = True
			
		oknoSoobscheniya = QMessageBox(self)
		oknoSoobscheniya.setText('Вы действительно хотите выйти из приложения?')
		oknoSoobscheniya.setIcon(QMessageBox.Question)
		oknoSoobscheniya.setWindowTitle('Подтверждение')
		oknoSoobscheniya.addButton('Нет' if not esperanto else 'Nuligi', QMessageBox.NoRole)
		oknoSoobscheniya.addButton('Да' if not esperanto else 'Eliri', QMessageBox.YesRole)
		
		if esperanto:
			oknoSoobscheniya.setText('Ĉu vi volas eliri el la aplikaĵo?')
			oknoSoobscheniya.setWindowTitle('Elirdemando')
			
		otvet = oknoSoobscheniya.exec_()
				
		if otvet == 1:
			event.accept()
		else:
			event.ignore()
		
if __name__ == "__main__":
	prilozheniye = QApplication(sys.argv)
	okno = Okno()
	sys.exit(prilozheniye.exec_())
